/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package primocomthread;

class ThreadPrimos extends Thread{
    private long [] vetqtd;
    private int indice;
    private long init, fim;
    
    
    public boolean ehPrimo(long nro){
    if (nro < 2 || nro % 2 == 0) return false;
    for (long i=3; i*i < nro; i+=2)
        if (nro % i == 0)
            return false;
    
    return true;
}
    
    
    public ThreadPrimos(long [] vetqtd, int indice, long tamSegmento){
        init = indice*tamSegmento;
        fim = indice*tamSegmento + tamSegmento-1;
        this.vetqtd = vetqtd;
        this.indice = indice;
        this.vetqtd[indice] = 0;
    }
    
    public void run(){
        System.out.println("dentro da thread");
        for (long i=init; i<=fim; i++)
            if (ehPrimo(i))
                vetqtd[indice]++;
    }
    
}



/**
 *
 * @author jbatista
 */
public class PrimoComThread {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws InterruptedException {
        // TODO code application logic here
        long valor = 10000000;
        long qtd = 0;
        long tamSegmento = 1000000;
        int nroThreads = (int) Math.ceil(valor / tamSegmento);
        ThreadPrimos [] vetThreads = new ThreadPrimos[nroThreads];
        long [] vetqtd = new long [nroThreads];
        
        for (int i=0; i< nroThreads; i++)
            vetThreads[i] = new ThreadPrimos(vetqtd, i, tamSegmento);
           
        
        
        
         for (int i=0; i< nroThreads; i++)
             vetThreads[i].start();
         
         
         for (int i=0; i< nroThreads; i++)
             vetThreads[i].join();
         
         
         
         
         for (int i=0; i< nroThreads; i++)
             qtd = qtd + vetqtd[i];
         
         System.out.println("Eu sou uma thread = " + Thread.currentThread().getName());
          System.out.println("Temos " + qtd + " numeros primos entre 0 e " + valor);

        
        
        
        
    }
    
}
